\documentclass{article}
\usepackage[utf8]{inputenc}
\usepackage[T1]{fontenc}
\usepackage[english]{babel}
\usepackage{hyperref}

% bibliography
\usepackage[backend=biber,style=numeric,sorting=none]{biblatex}
\usepackage{csquotes}
\addbibresource{bibliography.bib}

% tables
\usepackage{changepage}
\usepackage{multirow,tabularx}

%images
\usepackage{graphicx}
\usepackage{graphbox}

% folder structure
\usepackage{dirtree}

% modulo
\usepackage{mathtools}

% inline fractions
\usepackage{nicefrac}

% code
\usepackage{listings}
\usepackage{xcolor}
\definecolor{backcolour}{rgb}{0.95,0.95,0.92}
\lstdefinestyle{mystyle}{
    backgroundcolor=\color{backcolour},   
    commentstyle=\color{green},
    keywordstyle=\color{blue},
    numberstyle=\tiny\color{gray},
    stringstyle=\color{purple},
    basicstyle=\ttfamily\footnotesize,
    breakatwhitespace=true,         
    breaklines=true,                 
    captionpos=b,                    
    keepspaces=true,                 
    numbers=left,                    
    numbersep=5pt,                  
    showspaces=false,                
    showstringspaces=false,
    showtabs=false,                  
    tabsize=2
}
\lstset{style=mystyle}

\title{Metodi del calcolo scientifico: progetto 2}
\author{    
    Marco Magni\\
    851810
}
\date{September 2023}

\begin{document}

\maketitle
\begin{abstract}
    \textit{Part 1}: Implementation of a home-made DCT2 in Python and comparison with one of a known library in its FFT version.

    \textit{Part 2}: Implementation of a GTK4 Python GUI to compress a bitmap image using DCT2.
\end{abstract}

\section{Introduction}

This project has been done as the second of the two assignments for Master's degree course of \textit{Metodi del calcolo scientifico (Scientific computing methods)}.

The project itself is divided in two main parties, which will be called \textit{Part 1} and \textit{Part 2} from now on.

The purpose of the first part is to implement a home-made DCT2 in an open source environment, with the desired programming language.
After that, compare execution times of own implementation with the FFT version of a known library's one.

Part 2's aim, instead, is to create a GUI to let the user choice a bitmap image and some parameters (which will be deepened in Section \ref{section:part2-code}) and to apply the library's DCT2 in order to obtain a compressed image and to visualize it near the original one.

In the following sections will be analyzed the architecture of the project, the code behind it and the results obtained, both for \textit{Part 1} and \textit{Part 2}.

The project is public and available on GitLab.\cite{gitlab}

\section{Architecture}

It has been developed a single project for both \textit{Part 1} and \textit{Part 2}.

The open source environment chosen has been Gnome's GTK 4, using bindings for Python programming language.
As its official documentation website says, \textquote{GTK is a library for creating graphical user interfaces. It works on many UNIX-like platforms, Windows, and macOS}. And most importantly, \textquote{GTK is released under the terms of the GNU Library General Public License, which allows for flexible licensing of client applications}.\cite{gtk, gtk-docs}

The folder structure is the following (only project-strictly-related files are considered, ignoring version-control files and so on).

\vspace{10pt}

\dirtree{%
.1 JpegCompressor.
.2 data.
.3 160x160.bmp.
.3 20x20.bmp.
.3 320x320.bmp.
.3 40x40.bmp.
.3 640x640.bmp.
.3 80x80.bmp.
.3 bridge.bmp.
.3 cathedral.bmp.
.3 deer.bmp.
.3 gradient.bmp.
.3 prova.bmp.
.3 shoe.bmp.
.2 functions.
.3 compression.py.
.3 homemade.py.
.2 output.
.3 ....
.2 windows.
.3 home.py.
.3 part1.py.
.3 part2.py.
.2 main.py.
}

\vspace{10pt}

The \textit{data} folder contains some sample bitmap images, ready to be chosen when dealing with \textit{Part 2}.

The \textit{functions} folder contains two modules. Each of them contains the implementation of the functions needed for the relative part.

As its name suggests, the \textit{output} folder contains will contain all of the files generated by the program. These include time comparison csv, compressed images, plot, etcetera.

The \textit{windows} folder contains three files, one for each windows, in fact.
The \textit{home} window has a simple menu to let the user choice which part of the project to examine by opening the relative window.

The \textit{main} is the actual program, which acts as an entry point to the application; after doing its basic operations, it instantiates a \textit{home} window to allow the user to interact with the GUI with the aim of comparing the implemented DCT2 or compressing the choosen bitmap image.

\section{Part 1}

\subsection{Code}

\textit{Part 1} window consists in a mask with 3 buttons, a log label and a plot canvas. Every button is binded with a function, while the log label's purpose is to inform the user about the program execution status.

The functions available are:

\begin{itemize}
    \item \textit{Home-made DCT test}: the program executes the home-made implementation of DCT with the test matrix's first row to check if the values are right according to the given ones. It outputs the result in a csv file.
    \item \textit{Home-made DCT2 test}: the program executes the home-made implementation of DCT2 with the test matrix to check if the values are right according to the given ones. It outputs the result in a csv file.
    \item \textit{Compare execution times}: the program creates random matrices of different dimensions (1000, 2000, 4000, 8000). Then it executes both home-made DCT2 and SciPy's one. It generates a plot showing the execution times and outputs the plot itself as a png image and a csv file containing the execution times for each matrix processed.
\end{itemize}

\subsection{Considerations}

Results obtained are aligned with expectations.

The first two functions work correctly. In fact the executions of the home-made implementations return the same values, despite a little bit of negligible difference. That means that both mono-dimensional DCT and bi-dimensional DCT2 are correct and reliable.

The third function shows how the home-made DCT2's computational complexity is $O(n^3)$. As expected, it's one order of magnitude slower than the SciPy library's one, which, in its FFT version, is $O(n^2)$.

\section{Part 2}

\subsection{Code}
\label{section:part2-code}

\textit{Part 2} window consists in a mask with three input fields and one button. The inputs are:

\begin{itemize}
    \item \textit{Image}: a common file picker to choose from the filesystem the bitmpap image to be compressed.
    \item \textit{F} parameter: an integer number; it represents the size of each of DCT2's windows.
    \item \textit{d} parameter: an integer number between $0$ and $(2F - 2)$; it represents the frequencies cut-off threshold.
\end{itemize}

When submitted the start procedure button, the compression algorithm implemented works like described in the following steps.

\begin{itemize}
    \item If the dimensions of the image are not a multiple of \textit{F}, the image will be cut, discarding all of the excesses.
    An image measuring $n \times m$, for instance, will contain a number of blocks equals to:
    
    $(\nicefrac{(n - (n \mod{F}))}{F})(\nicefrac{(m - (m \mod{F}))}{F})$
    
    So, the compressed image's dimensions will be:
    
    $(n - (n \mod{F})) \times (m - (m \mod{F}))$
    \begin{lstlisting}[language=Python]
h = image.shape[0]
w = image.shape[1]
if h%F != 0:
    h = int(h / F) * F
if w%F != 0:
    w = int(w / F) * F
image_to_compress = image[0:h, 0:w]\end{lstlisting}
    \item The image will be processed one block at a time.
    \begin{lstlisting}[language=Python]
for x in range(0, h, F):
    for y in range(0, w, F):
        block = image_to_compress[x:x+F, y:y+F]\end{lstlisting}
    \item SciPy's DCT2 is applied.
    \begin{lstlisting}[language=Python]
        block = dctn(block, type = 2, norm = 'ortho')\end{lstlisting}
    \item Frequencies $block_{ij}$ such that $i + j >= d$ are cut.
    \begin{lstlisting}[language=Python]
        for i in range(0, F):
            for j in range(0, F):
                if i + j >= d:
                    block[i, j] = 0\end{lstlisting}
    \item SciPy's inverse DCT2 is applied.
    \begin{lstlisting}[language=Python]
        block = idctn(block, type = 2, norm = 'ortho')\end{lstlisting}
    \item Values are rounded to the nearest integer, negative values are set to 0 and values greather than 255 are set to 255.
    \begin{lstlisting}[language=Python]
        for i in range(0, F):
            for j in range(0, F):
                value = np.round(block[i, j])
                if value < 0:
                    value = 0
                elif value > 255:
                    value = 255
                block[i, j] = value\end{lstlisting}
    \newpage
    \item The processed block will be part of the compressed image.    
    \begin{lstlisting}[language=Python]
        compressed_image[x:x+F, y:y+F] = block\end{lstlisting}
    \item Previous steps are repeated for each block.
    \item After that, the original image and the compressed one are visualized on the screen side by side to allow the user to compare them easily.
\end{itemize}

In Figure \ref{figure:compressed-images} are shown a couple of the given sample images after the execution of the compression procedure, with parameters set as $F = 10; d = 7$.
It is possible to notice that the compressed images present the Gibbs phenomenon. 

\begin{figure}
    \centering
    \includegraphics[height=120pt,align=c]{images/prova.jpeg}
    \includegraphics[height=120pt,align=c]{images/deer.jpeg}
    \caption{Compressed images, from left: prova.bmp, deer.bmp}
    \label{figure:compressed-images}
\end{figure}

\subsection{Considerations}

Compression algorithm is effective and aligned with expecations, too.

To be noted that:

\begin{itemize}
    \item variations in \textit{F} parameter causes variations of the compressed image size since the original image size may not be a multiple of \textit{F}, resulting in cutting out the excesses.
    \item Increasing \textit{d} parameter results in decreasing the loss of information and in obtaining an image more faithful to the original one.
\end{itemize}

\printbibliography

\end{document}
